; ---------------------------------------------------------------------------------
SetFont		macro						; in : Fontsize
	PushAll							;	0: smallest
	move.w		\1,-(a7)				;	1: normal
	jsr			doorsos::FontSetSys		;	2: bigest
	addq.l		#2,a7					; out: nothing
	PopAll							; NO REGS DESTROYED
			endm
; ---------------------------------------------------------------------------------
WriteStr		macro						; in : X,Y,Style,Text
	movem.l		d0-d7/a0-a5,-(a7)		; Style:
	move.w		\3,-(a7)				;	0 
	pea			\4(pc)				;	1
	move.w		\2,-(a7)				;	2
	move.w		\1,-(a7)				;	3
	jsr			doorsos::DrawStrXY		;	4
	lea			10(a7),a7				; out: nothing
	movem.l		(a7)+,d0-d7/a0-a5		; NO REGS DESTROYD
                endm

; ---------------------------------------------------------------------------------
clrscr		Macro						; Clears the whole Screen
	jsr			graphlib::clr_scr		; NO REGS DESTROYD
			ENDM

; ---------------------------------------------------------------------------------
clrscr2		Macro						; Clears the Screen and Draw
	jsr			graphlib::clr_scr2		; the Statusbar line
			ENDM						; NO REGS DESTROYD
			
; ---------------------------------------------------------------------------------
idleloop		macro						; Waits for a Key
	jsr			userlib::idle_loop		; out: D0.W = Keycode
			endm

; ---------------------------------------------------------------------------------
idlehot		macro						; Waits for a Key
	jsr			userlib::idle_hot		; out: D0.W = Keycode
			endm						; F7 protect calc; F8 Shut it down

; ---------------------------------------------------------------------------------
DrawBarXY		macro						; Draws a Bar
	movem.l		d0-d4,-(a7)			; In: X,Y,width,height,color.W
	move.w		\1,d0					; Color:
	move.w		\2,d1					;	0: Xorput
	move.w		\3,d2					;	1: withe
	move.w		\4,d3					;	2: black
	move.w		\5,d4					; NO REGS DESTROYD
	jsr			graphlib::fill
	movem.l		(a7)+,d0-d4
			EndM

; ---------------------------------------------------------------------------------
vert			macro						; Draws a vertical Line
	movem.l		d0-d2,-(a7)			; In: X,Y1,Y2.W
	move.w		\1,d0
	move.w		\2,d1
	move.w		\3,d2					; NO REGS DESTROYD
	jsr			graphlib::vert
	movem.l		(a7)+,d0-d2
			EndM
; ---------------------------------------------------------------------------------
horiz			macro						; Draws a horizontal Line
	movem.l		d0-d3,-(a7)			; In: Y,X1,X2.W
	move.w		\1,d1
	move.w		\2,d0
	move.w		\3,d2					; NO REGS DESTROYD
	move.w		#2,d3
	jsr			graphlib::horiz
	movem.l		(a7)+,d0-d2
			EndM

; ---------------------------------------------------------------------------------
WriteHex		macro						; Write a Hexnumber
	movem.l		d0-d7/a0-a5,-(a7)		; In: X,Y,Number,Digits
	move.l		\1,-(a7)
	move.l		\2,-(a7)
	move.l		\3,-(a7)
	move.l		\4,-(a7)
	move.l		(a7)+,d4
	move.l		(a7)+,d0
	move.l		(a7)+,d2
	move.l		(a7)+,d1
	jsr			hexlib::put_hex
	movem.l		(a7)+,d0-d7/a0-a5
			endm

; ---------------------------------------------------------------------------------
DelVar		macro						; delete the variable pointed to mem
	move.l		a0,-(a7)				; In: var,number
	lea			\(PC),a0
	FillMem		a0,\2,#0
	move.l		(a7)+,a0
			endm
; ---------------------------------------------------------------------------------
DelVarEx		macro						; delete the variable pointed to mem with a byte
	move.l		a0,-(a7)				; In: var,number,witchbyte
	lea			\(PC),a0
	FillMem		a0,\2,\3
	move.l		(a7)+,a0
			endm

; ---------------------------------------------------------------------------------
CreateFolder	macro						; create a Folder
	move.l		a0,-(a7)				; In: .L folder
	lea			\1(PC),a0
	jsr			filelib::createfolder
	move.l		(a7)+,a0
		endM

; ---------------------------------------------------------------------------------
PushAll		macro
	movem.l		d0-d7/a0-a6,-(a7)
		endM

; ---------------------------------------------------------------------------------
PopAll		macro
	movem.l		(a7)+,d0-d7/a0-a6
		endM

; ---------------------------------------------------------------------------------
CreateHandle	macro						; Create a Handle
	movem.l		d1-d7/a0-a6,-(a7)
	move.l		\1,-(a7)				; in  : .L size of Handle
	jsr			doorsos::HeapAlloc		; out : d0.w = Handle
	adda.l		#4,a7
	movem.l		(a7)+,d1-d7/a0-a6
			EndM

; ---------------------------------------------------------------------------------
; ---------------------------------------------------------------------------------
; ---------------------------------------------------------------------------------
; ---------------------------------------------------------------------------------
; ---------------------------------------------------------------------------------
; ---------------------------------------------------------------------------------
; ---------------------------------------------------------------------------------
