	include		"doorsos.h"
	include		"graphlib.h"
	include		"userlib.h"
	include		"filelib.h"
	include		"misclib.m"
	include		"abutils.asm"
	include		"hexlib.h"

;----------------------------------------------------------------------------------
	xdef			_ti92plus
	xdef    		_library

	xdef			misclib@0000				; GetKeyCode
	xdef			misclib@0001				; Vertical
	xdef			misclib@0002				; Horizontal
	xdef			misclib@0003				; mod
	xdef			misclib@0004				; div
	xdef			misclib@0005				; IntToStr
	xdef			misclib@0006				; IntToStrL
	xdef			misclib@0007				; FillMem
	xdef			misclib@0008				; ShowError
	xdef			misclib@0009				; CompareMem
	xdef			misclib@000A				; SearchFile
	xdef			misclib@000B				; SearchFolder
	xdef			misclib@000C				; MoveMem
	xdef			misclib@000D				; RestoreScreen
	xdef			misclib@000E				; SaveScreen
	xdef			misclib@000F				; DrawBox
	xdef			misclib@0010				; DeleteFile
	xdef			misclib@0011				; DeleteFileEx
	xdef			misclib@0012				; DrawFrame
	xdef			misclib@0013				; PutImage
	xdef			misclib@0014				; CreateFile
	xdef			misclib@0015				; DestroyHandle
	xdef			misclib@0016				; WaitForKey
	xdef			misclib@0017				; CFolderList
	xdef			misclib@0018				; CFileList
	xdef			misclib@0019				; SendByte
	xdef			misclib@001A				; ReceiveByte
	xdef			misclib@001B				; GetFolderInfo
	xdef			misclib@001C				; DerefD0A0
	xdef			misclib@001D				; ListBox
	xdef			misclib@001E				; ListBoxEA
	xdef			misclib@001F				; CheckBoxEA
	xdef			misclib@0020				; GetDLEntry

;----------------------------------------------------------------------------------
misclib@0000:								; GetKeyCode
	clr.l			d0
	tst.w			doorsos::kb_vars+$1C
	beq			GetKeyCodeReturn
	move.w		doorsos::MaxHandles+$1E,d0
	clr.w			doorsos::kb_vars+$1C
GetKeyCodeReturn:
	rts

;----------------------------------------------------------------------------------
misclib@0001:								; Vertical
	move.w		#0,d1						
	move.w		#127,d2
	jsr			graphlib::vert
	rts

;----------------------------------------------------------------------------------
misclib@0002:								; Horizontal
	move.w		#0,d0
	move.w		#239,d2
	move.w		#2,d3
	jsr			graphlib::horiz
	rts

;----------------------------------------------------------------------------------
misclib@0003:								; mod
	move.l		(a7)+,exitcode
	clr.l			d0
	clr.l			d1
	move.w		(a7)+,d1					;d0 = dividend
	move.w		(a7)+,d0					;d1 = divisor
	move.l		d0,d2
	divu			d1,d0
	mulu.l		d1,d0
	sub.l			d0,d2
	move.l		d2,d0
	move.l		exitcode,-(a7)
	rts

;----------------------------------------------------------------------------------
misclib@0004:								; div
	move.l		(a7)+,exitcode
	move.l		(a7)+,d1
	move.l		(a7)+,d0
	jsr			doorsos::_du32u32
	move.l		d1,d0
	move.l		exitcode,-(a7)
	rts
	
;----------------------------------------------------------------------------------

;----------------------------------------------------------------------------------
misclib@0005:								; IntToStr
	move.l		#4,d3
	move.l		d4,d0
	move.l		#10000,d1
 itslp1:
	move.l		d0,d2
	div			d1,d0
	add.b			#48,d0
	move.b		d0,-(a7)
	sub.b			#48,d0
	mulu			d1,d0
	sub.l			d0,d2
	move.l		d2,d0
	divu			#10,d1
	dbra			d3,itslp1
	move.l		d5,a0
	add.l			#5,a0
	move.l		#4,d0
 itslp2:
	move.b		(a7)+,-(a0)
	dbra			d0,itslp2
	rts

;----------------------------------------------------------------------------------
misclib@0006:								; IntToStrL
	move.l		#4,d3
	move.l		d4,d0
	move.l		#10000,d1
 itsllp1:
	move.l		d0,d2
	div			d1,d0
	add.b			#48,d0
	move.b		d0,-(a7)
	sub.b			#48,d0
	mulu			d1,d0
	sub.l			d0,d2
	move.l		d2,d0
	divu			#10,d1
	dbra			d3,itsllp1
	move.l		d5,a0
	add.l			#5,a0
	move.l		#4,d0
 itsllp2:
	move.b		(a7)+,-(a0)
	dbra			d0,itsllp2
	move.l		d5,a0
 itsllp3:
	cmp.b			#48,(a0)+
	beq			itsllp3
	sub.l			#1,a0
	move.l		d5,a1
	move.l		#4,d0
 itsllp4:		
	move.b		(a0)+,(a1)+
	dbra			d0,itsllp4	
	rts

;---------------------------------------------------------------------------------
misclib@0007:								; FillMem
	move.l		(a7)+,exitcode
	jsr			doorsos::memset
	adda.l		#10,a7
	move.l		exitcode,-(a7)
	rts
	
;----------------------------------------------------------------------------------
misclib@0008:								; ShowError
	move.w		d0,-(a7)
	jsr			doorsos::ERD_dialog
	add.w			#2,a7
	rts

;----------------------------------------------------------------------------------
misclib@0009:								; CompareMem
	move.l		d0,-(a7)
	move.l		a1,-(a7)
	move.l		a0,-(a7)
	jsr			doorsos::memcmp
	adda.l		#12,a7
	rts
;----------------------------------------------------------------------------------
_searchfile:						
	jsr			_searchfolder
	tst.w			d0
	beq			SfNotFound
	move.l		a1,-(a7)
	move.w		d0,-(a7)
	jsr			userlib::FindSymEntry
	add.l			#6,a7
	cmpa.l		#0,a0
	beq			SfNotFound
	bra			SfFound
 SfNotFound:								; if not found: a0=0
	move.l		#0,a0
	move.w		#0,d1
	rts
 SfFound:
	move.w		12(a0),d1					; D0.w	Folder Hanlde
	move.w		d1,d2						; A0.l	Adress of VAT
	DEREF			d2,a1						; D1.w	File Handle
	move.w		(a1),d2					; D2.w 	File Length-2
	rts									; A1.l	Adress of file

_searchfolder:
	move.l		a0,-(a7)
	move.w  		#$08,-(a7)
	jsr     		userlib::FindSymEntry
	addq.l  		#6,a7
	cmpa.l		#0,a0
	beq			_SFErr					; A0.L	Folder VAT entry
	move.w		12(a0),d0					; D0.W	Folder Handle
	rts
_SFErr:
	move.w		#0,d0						; if not found: D0.W = 0
	rts

;----------------------------------------------------------------------------------
misclib@000A:								; SearchFile
	jsr			_searchfile
	rts

;----------------------------------------------------------------------------------
misclib@000B:								; SearchFolder
	jsr			_searchfolder
	rts

;----------------------------------------------------------------------------------
misclib@000C:								; MoveMem
	move.l		d0,-(a7)
	move.l		a0,-(a7)
	move.l		a1,-(a7)
	jsr			doorsos::memmove
	adda.l		#12,a7
	rts

;----------------------------------------------------------------------------------
misclib@000D:								; RestoreScreen
	tst.w		d4
	beq		ERS
	move.w		#0,d0
	move.w		#0,d1
	move.w		#30,d2
	move.w		#128,d3
	jsr			graphlib::memtoscr
 ERS:
	rts	

;----------------------------------------------------------------------------------
misclib@000E:								; SaveScreen
	movem.l		d1-d4,-(a7)
	clr.w			d0
	clr.w			d1
	move.w		#LCD_LINE_BYTES,d2
	move.w		#LCD_HEIGHT,d3
	jsr			graphlib::scrtomem
	move.w		d4,d0
	movem.l		(a7)+,d1-d4
	rts

;----------------------------------------------------------------------------------
misclib@000F:								; DrawBox
	SaveScreen
	move.w		d0,d7
	move.l		(a7)+,exitcode
	move.l		(a7)+,a1
	move.l		(a7)+,a0
	move.w		(a7)+,d3
	move.w		(a7)+,d2
	move.w		(a7)+,d1
	move.w		(a7)+,d0
	move.w		d0,d5
	move.w		d1,d6
	jsr			graphlib::box
	SetFont		#1
	move.w		d6,d2
	move.w		d5,d1
	add.w			#6,d1
	add.w			#15,d2
 DrBxLp1:
	cmpi.b		#0,(a1)
	beq			DrBxF
	move.b		(a1)+,d3
	cmp.b			#13,d3
	beq			DrBxEnter
	bra			DrBxPutChar
 DrBxEnter:
	add.w			#10,d2
	move.w		d5,d1
	add.w			#6,d1
	bra			DrBxLp1
 DrBxPutChar:
	move.b		d3,char
	WriteStr		d1,d2,#4,char
 	add.w			#6,d1
	bra			DrBxLp1
 DrBxF:
	move.w		d7,d0
	move.l		exitcode,-(a7)
	rts

char				dc.b		0,0

; ---------------------------------------------------------------------------------
misclib@0010:								; DeleteFile
	move.w		d1,d2
	jsr			filelib::hdltoindex
	jsr			filelib::unhide
	jsr			filelib::delete
	rts


; ---------------------------------------------------------------------------------
misclib@0011:								; DeleteFileEx
	move.w		d1,d2
	jsr			filelib::hdltoindex
	jsr			filelib::delete
	rts

;----------------------------------------------------------------------------------
misclib@0012:								; DrawFrame
		move.l		(a7)+,a0
		move.w		(a7)+,d5
		move.w		(a7)+,d4
		move.w		(a7)+,d1
		move.w		(a7)+,d0
		move.l		a0,-(a7)
		jsr			graphlib::frame
		rts

;----------------------------------------------------------------------------------
misclib@0013:								; PutImage
	move.l	#%11111111,d3
	jsr		graphlib::put_sprite_mask
	rts

;----------------------------------------------------------------------------------
misclib@0014:								; CreateFile
	SearchFolderEA	a1		
	tst.w			d0
	beq			cf_err1
	move.l		a2,a0
	jsr			filelib::createfile	
	tst.w			d2
	bne			cf_err2
	move.w		d5,d0
	jsr			filelib::resizefile
	cmp.w			d0,d5
	bne			cf_err3
	SearchFileEA	a2,a1
	move.b		d6,11(a0)
	move.b		d7,1(a1,d2.w) 
	move.w		#0,a6
	rts

cf_err1:
	move.w		#1,a6
	rts

cf_err2:
	addq.w		#1,d2
	move.w		d2,a6
	rts
cf_err3:
	PushAll
	move.w		12(a0),d1
	jsr			misclib@0010
	PopAll
	move.w		#2,a6
	rts

;----------------------------------------------------------------------------------
misclib@0015:								; DestroyHandle
	tst.w			d0
	beq			_DHend
	move.w		d0,-(a7)			
	jsr			doorsos::HeapFree
	add.l			#2,a7
 _DHend:
	rts	

;----------------------------------------------------------------------------------
misclib@0016:								; WaitForKey
_waitforkey
	idleloop
	cmp.w		d0,d1
	bne		_waitforkey
	rts

;----------------------------------------------------------------------------------
_cfoldlist:
	move.w		#$08,d0
	bra			_clist
_clist:
	movem.l		d1-d7/a1-a6,-(a7)
	DEREF			d0,a0
	move.l		a0,a3
	clr.l			d1
	clr.l			d0
	move.w		2(a0),d1
	tst.w			d1
	beq			_cfnolist
	move.l		d1,d7
	sub.l			#1,d7
	mulu			#15,d1
	add.w			#1,d1
	move.l		d1,-(a7)
	jsr			doorsos::HeapAlloc
	move.w		d0,d6
	add.l			#4,a7
	tst.w			d0
	beq			_cflistend
	move.l		a3,a0
	add.w			#4,a0
	DEREF			d0,a1
	move.l		a1,a2
  cflistif2:
	cmp.b			#48,(a0)
	beq			cflistn2
 cflistlp1:
	move.b		#32,(a1)+
	move.b		#32,(a1)+
	move.b		#32,(a1)+
	move.l		#7,d1
  cflistlp2:
	move.b		(a0)+,d3
	cmp.b			#0,d3
	beq			cflistif1
	move.b		d3,(a1)+
	bra			cflistn1
   cflistif1:
	move.b		#32,(a1)+
   cflistn1:
	dbra			d1,cflistlp2
	adda.l		#6,a0
	move.b		#32,(a1)+
	move.b		#32,(a1)+
	move.b		#32,(a1)+
	move.b		#13,(a1)+
	dbra			d7,cflistlp1
	move.b		#0,(a1)
_cflistend:
	move.l		a2,a0
	move.l		d6,d0
	movem.l		(a7)+,d1-d7/a1-a6
	rts
cflistn2:
	adda.l		#14,a0
	subq.w		#1,d7
	bra			cflistif2
_cfnoliststr		dc.b	"   (no var)   ",13,0
_cfnolist:
	CreateHandle	#16
	lea			_cfnoliststr(PC),a0
	clr.l			d6
	move.w		d0,d6
	DEREF			d0,a2
	move.l		#15,d0
	move.l		a2,a1
 _cfnolistlp1:
	move.b		(a0)+,(a1)+
	dbra			d0,_cfnolistlp1
	bra			_cflistend

;----------------------------------------------------------------------------------
misclib@0017								; CFolderList
	jsr			_cfoldlist
	rts

;----------------------------------------------------------------------------------
misclib@0018								; CFileList
	jsr			_clist
	rts
;----------------------------------------------------------------------------------
misclib@0019								; SendByte
	move.l		a0,-(a7)
	move.b  		d0,sblinkbuf
	move.w  		#1,-(a7)
	pea	 		sblinkbuf(PC)
	jsr 			doorsos::transmit
	addq			#6,a7
	move.l		(a7)+,a0
	rts

sblinkbuf			dc.w	0

;----------------------------------------------------------------------------------
misclib@001A								; ReceiveByte
 	movem.l 		d2/a0-a1,-(a7)
 	clr.b	 		rblinkbuf
 	move.w  		#1,-(a7)
 	pea	 		rblinkbuf(PC)
 	jsr 			doorsos::receive
 	addq	 		#6,a7
	move.l		d0,d1
 	clr.l	 		d0
 	move.b  		rblinkbuf(PC),d0
 	movem.l 		(a7)+,d2/a0-a1
 	rts

rblinkbuf			dc.w	0

;----------------------------------------------------------------------------------
misclib@001B								; GetFolderInfo
	movem.l		d1-d7/a1-a6,-(a7)
	DEREF			d0,a1						; a1 points to folder
	clr.l			d0
	cmpa.l		#0,a1
	beq			gfiret
	move.w		2(a1),d0
	mulu			#2,d0
	add.l			#20,d0
	CreateHandle	d0
	tst.w			d0
	beq			gfiret
	move.w		d0,d7
	DeRefD0A0								; a0 points to structur
	move.w		2(a1),(a0)
	beq			gfiret
	clr.l			d1
	move.w		2(a1),d1
	sub.w			#1,d1						; d1 = how many files-1
	move.w		d1,d6						; d6 = how many files-1
	move.l		#16,d2
	move.l		#14,d3
 gfiLp1:
	move.w		0(a1,d2.w),0(a0,d3.w)
	add.l			#14,d2
	addq.l		#2,d3
	dbra			d1,gfiLp1					
	move.l		a0,a1
	adda.l		#14,a1					; a1 points to handlelist
	move.l		a0,a2						; a2 points to Structur
	clr.l			d2						; d2 = total size
	clr.l			d3						; d3 = max size
	move.w		#$ffff,d4					; d4 = min size
 gfiLp2:
	move.w		(a1)+,d0
	DeRefD0A0
	clr.l			d5
	move.w		(a0),d5
	addq.w		#2,d5
	add.l			d5,d2
	cmp.l			d5,d3
	bcs			gfibigest
 gfin1:
	cmp.l			d5,d4
	bhi			gfismallest
 gfin2:
	dbra			d6,gfiLp2
	move.l		d2,2(a2)
	move.l		d3,6(a2)
	move.l		d4,10(a2)
	move.w		d7,d0
 gfiret:
	movem.l		(a7)+,d1-d7/a1-a6
	rts
 
 gfibigest:
	move.l		d5,d3
	bra			gfin1
 gfismallest:
	move.l		d5,d4
	bra			gfin2

;----------------------------------------------------------------------------------
misclib@001C:								;DerefD0A0
	movem.l		d0-d7/a1-a6,-(a7)
	DEREF			d0,a0
	movem.l		(a7)+,d0-d7/a1-a6
	rts

;----------------------------------------------------------------------------------
_listboxpop:
	move.l		(a7)+,exitcode
	move.l		#0,a4
	move.l		#0,a5
	move.l		#0,a6
	clr.l			d3
	clr.l			d2
	clr.l			d1
	clr.l			d0
	move.w		(a7)+,a6
	move.w		(a7)+,a4
	move.w		(a7)+,a5
	move.b		(a7)+,d3
	move.b		(a7)+,d2
	move.b		(a7)+,d1
	move.b		(a7)+,d0
	move.l		exitcode,-(a7)
_listbox:
	move.l		d0,d7
	SetFont		#1
	move.w		a4,d4
	move.b		d4,lbi2
	move.w		a5,d4
	move.b		d4,lbi3
	add.w			a4,d4
	move.b		d4,lbi1			;lbi3  = momentane Zeile
	clr.l			d4			;lbi2  = Oberer Rand
	move.w		d3,d4			;lbi1  = Absoluter Index
	divu			#10,d4			;lbc   = Anzahl Zeilen
	move.b		d4,lbc
	lea			lbbuffer(PC),a1		; a1 points to buffer
	move.l		a0,a3			; a0,a3 points to list
	move.l		a1,a2			; a2 points to buffer
	move.l		#0,d6
 lblp0:
	move.b		(a0)+,d0
	cmp.b			#13,d0
	beq			lblp0add
	cmp.b			#0,d0
	beq			lblp0end
	bra			lblp0
    lblp0add:
	add.b			#1,d6
	bra			lblp0
    lblp0end:
	sub.b			#1,d6			; d6 = how many lines
 _lbShow:					; Shows the visible lines
	clr.l			d5
	move.l		a2,a1			; a1 points to buffer
	move.l		a3,a0			; a0 points to list
 _lblp1:
	move.b		(a0)+,(a1)+
	cmp.b			#0,(a0)
	beq			_lblp2
	cmp.b			#13,(a0)		; a1 points to the current line
	beq			lbtestline
	bra			_lblp1
 lbtestline:					
	move.b		#0,(a1)			; Terminate the line
	move.l		a2,a1			; a1 points to buffer
	addq.l		#1,a0			; a0 points to next line in list
	cmpi.b		#0,(a0)
	bne			lbtestline1
	subq.l		#1,a0			; a0 points to next line in list
 lbtestline1:
	clr.l			d4
	move.b		d5,d4
	sub.b			lbi2,d4
	cmp.b			lbc,d4
	bcs			lbtestline2
	addq.b		#1,d5
	bra			_lblp1
 lbtestline2:
	clr.l			d4
	move.b		d5,d4
	sub.b			lbi2,d4
	mulu			#10,d4
	add.b			d1,d4
	cmp.b			lbi1,d5
	beq			lbtestline2_1
	DrawBarXY		d7,d4,d2,#10,#1
	WriteStr		d7,d4,#4,lbbuffer
	add.b			#1,d5
	bra			_lblp1
   lbtestline2_1:
	DrawBarXY		d7,d4,d2,#10,#1
	WriteStr		d7,d4,#0,lbbuffer
	add.b			#1,d5
	bra			_lblp1

 _lblp2:
	jsr			userlib::idle_hot
	cmp.w			#0,d0
	bne			_lbtestkey1
 _lbkeynext:
	cmp.w			#264,d0
	beq			_lbexitcanc	
	cmp.w			#13,d0
	beq			_lbexitselect
	cmp.w			#344,d0
	beq			lbdown
	cmp.w			#348,d0
	beq			lbdown
	cmp.w			#345,d0
	beq			lbdown
	cmp.w			#338,d0
	beq			lbup
	cmp.w			#339,d0
	beq			lbup
	cmp.w			#342,d0
	beq			lbup
	cmp.w			#337,d0
	beq			lbfirst
	cmp.w			#340,d0
	beq			lblast
	cmp.w			#0,d0
	bne			_lbtestkey2
	bra			_lblp2
 _lbtestkey1:
	cmp.w			#1,a6
	beq			_lbsavekey
	bra			_lbkeynext
 _lbtestkey2:	
	cmp.w			#2,a6
	beq			_lbsavekey
	bra			_lblp2
 _lbsavekey:
	move.w		d0,d3
	clr.l			d0
	clr.l			d1
	clr.l			d2
	move.b		lbi1,d0
	add.b			#1,d0
	move.b		lbi3,d1
	move.b		lbi2,d2
	bra			_lbexitsub
 _lbexitcanc:
	clr.l			d0
	clr.l			d1
	clr.l			d2
	move.w		#264,d3
	move.b		#0,d0
	move.b		lbi3,d1
	move.b		lbi2,d2
	bra			_lbexitsub
 _lbexitselect:
	clr.l			d0
	clr.l			d1
	clr.l			d2
	move.w		#13,d3
	move.b		lbi1,d0
	add.b			#1,d0
	move.b		lbi3,d1
	move.b		lbi2,d2
	bra			_lbexitsub
 lbup:
	cmp.b			#0,lbi1
	beq			_lblp2
	sub.b			#1,lbi1
	cmp.b			#0,lbi3
	beq			lbuplbi1
	sub.b			#1,lbi3
	bra			_lbShow
  lbuplbi1:
	sub.b			#1,lbi2
	bra			_lbShow
	
 lbdown:
	cmp.b			lbi1,d6
	beq			_lblp2
	add.b			#1,lbi1
	move.b		lbc,d4
	sub.b			#2,d4
	cmp.b			lbi3,d4
	bcs			lbdownlbi1
	add.b			#1,lbi3
	bra			_lbShow
 lbfirst:
	move.b		#0,lbi1
	move.b		#0,lbi2
	move.b		#0,lbi3
	bra			_lbShow
 lblast:
	cmp.b			lbc,d6
	bcc			lblastn0
	move.b		d6,lbi3
	bra			lblastn00
   lblastn0:	
	move.b		lbc,d4
	sub.b			#1,d4
	move.b		d4,lbi3
   lblastn00:
	move.b		d6,d4
	sub.b			lbc,d4
	add.b			#1,d4
	cmp.b			lbc,d6
	bcs			lblastn1
	move.b		d4,lbi2
  lblastn1:	
	move.b		d6,lbi1
	bra			_lbShow
 lbdownlbi1:
	add.b			#1,lbi2
	bra			_lbShow
 _lbexitsub:
	rts

lbbuffer			ds.b	50
lbc				dc.b	0
lbi1				dc.b	0
lbi2				dc.b	0
lbi3				dc.b	0

;----------------------------------------------------------------------------------
misclib@001D:								; ListBox
	bra			_listboxpop
;----------------------------------------------------------------------------------
misclib@001E:								; ListBoxEA
	bra			_listboxpop

;----------------------------------------------------------------------------------
_checkboxpop:
	move.l		(a7)+,exitcode
	clr.l			d7
	clr.l			d6
	clr.l			d5
	clr.l			d4
	clr.l			d3
	clr.l			d2
	clr.l			d1
	clr.l			d0
	move.w		(a7)+,d2
	move.w		(a7)+,d1
	move.b		(a7)+,d7
	move.b		(a7)+,d6
	move.b		(a7)+,d5
	move.b		(a7)+,d4
	move.l		exitcode,-(a7)
 cblp:
	ListBoxEA		a0,d4,d5,d6,d7,d1,d2,#2
	cmp.w			#32,d3
	bne			cbreturn
	PushAll
	move.l		#13,d2
	move.l		#1,d1
 cblp1:
	cmp.b			d1,d0
	beq			cbthen1
	cmp.b			(a0)+,d2
	bne			cblp1
	add.b			#1,d1
	bra			cblp1
 cbthen1:
	add.l			#1,a0
	cmp.b			#15,(a0)
	beq			cbdel
	cmpi.b		#183,(a0)
	beq			cbnext
	move.b		#15,(a0)
	bra			cbnext
   cbdel:
	move.b		#32,(a0)
   cbnext:
	PopAll
	bra			cblp
cbreturn:
	rts	

;----------------------------------------------------------------------------------
misclib@001F:								; CheckBoxEA
	bra			_checkboxpop

;----------------------------------------------------------------------------------
misclib@0020:								; GetDLEntry
	move.w		d6,d0						; D6 = Handle
	DeRefD0A0								; a0 points to list
	clr.l			d0						; D7 = Index
	move.b		d7,d0						; A1 points to buffer
	mulu			#15,d0					; Length of one line
	sub.w			#12,d0
	adda.l		d0,a0						; a0 points to entry
	move.l		#7,d1
  gdleLp1:									; Copy Foldername to var Folder
	cmp.b			#32,(a0)
	beq			gdleLp2
	move.b		(a0)+,(a1)+
	dbra			d1,gdleLp1
	bra			gdleRet
  gdleLp2:
	move.b		d5,(a1)+
	dbra			d1,gdleLp2
  gdleRet:
	move.b		#0,(a1)					; Terminate with #0	
	rts
;----------------------------------------------------------------------------------
;----------------------------------------------------------------------------------
;----------------------------------------------------------------------------------
;----------------------------------------------------------------------------------
;----------------------------------------------------------------------------------
;----------------------------------------------------------------------------------
exitcode		dc.l		0
;----------------------------------------------------------------------------------

	end
