; ---------------------------------------------------------------------------------
GetKeyCode		macro						; Look, if a Key is pressed
	jsr			misclib@0000			; out:	D0.W pressed Key
			endM
; ---------------------------------------------------------------------------------
Vertical		macro						; Draw a vertical Line
	movem.l		d0-d2,-(a7)			; In:		.W : X Position
	move.w		\1,d0
	jsr			misclib@0001
	movem.l		(a7)+,d0-d2
			EndM
; ---------------------------------------------------------------------------------
Horizontal		macro						; Draw a horizontal Line
	movem.l		d0-d3,-(a7)			; In:		.W : Y Position
	move.w		\1,d1
	jsr			misclib@0002
	movem.l		(a7)+,d0-d3
			EndM

; ---------------------------------------------------------------------------------
mod			macro						; 16Bit modulo divison
	movem.l		d1-d2,-(a7)			; In:		.W Dividend,Divisor
	move.w		\1,-(a7)				; out:	d0.W Result
	move.w		\2,-(a7)
	jsr			misclib@0003			; Example:
	movem.l		(a7)+,d1-d2			; mod #10,#4
			EndM						; d0 = #2

; ---------------------------------------------------------------------------------
div			macro						; 32Bit divison
	movem.l		d1-d7/a0-a5,-(a7)		; In:		.L Divisor, Dividend
	move.l		\1,-(a7)				; out:	d0.L Result
	move.l		\2,-(a7)
	jsr			misclib@0004			; Example:
	movem.l		(a7)+,d1-d7/a0-a5		; div #4,#15
			EndM						; d0 = #3

; ---------------------------------------------------------------------------------
IntToStr		macro						; Converts a word Integernumber to a String
	movem.l		d0-d6/a0,-(a7)			; at right side
	move.w		\1,-(a7)				; In:		.W Number
	pea			\2(PC)				;		.L Text
	move.l		(a7)+,d5
	clr.l			d4
	move.w		(a7)+,d4
	jsr			misclib@0005
	movem.l		(a7)+,d0-d6/a0
			endm

; ---------------------------------------------------------------------------------
IntToStrL		macro						; Converts a word Integernumber to String
	movem.l		d0-d6/a0,-(a7)			; at left side
	move.w		\1,-(a7)				; In:		.W Number
	pea			\2(PC)				;		.L Text
	move.l		(a7)+,d5
	clr.l			d4
	move.w		(a7)+,d4
	jsr			misclib@0006
	movem.l		(a7)+,d0-d6/a0
			endm

; ---------------------------------------------------------------------------------
FillMem		macro						; Fills the a number of byte in the memory
	movem.l		d0-d7/a0-a6,-(a7)		; with a byte
	move.l		\2,-(a7)				: In:		.L Evective Adresse
	move.w		\3,-(a7)				;		.L how many
	move.l		\1,-(a7)				;		.B witch byte
	jsr			misclib@0007
	movem.l		(a7)+,d0-d7/a0-a6
			endm
; ---------------------------------------------------------------------------------
ShowError		macro						; Shows a standard Error dialog
	movem.l		d0-d7/a0-a6,-(a7)		; In: 	Errornumber.W
	move.w		\1,d0
	jsr			misclib@0008
	movem.l		(a7)+,d0-d7/a0-a6
			endm

; ---------------------------------------------------------------------------------
CompareMem		macro						; Compare a few bytes of memory
	movem.l		d1-d7/a0-a6,-(a7)		; In:		.L <ea>1
	move.l		\1,-(a7)				;		.L <ea>2
	move.l		\2,-(a7)				;		.L how many bytes
	move.l		\3,-(a7)				; Out:	D0.W = 0 if equal
	move.l		(a7)+,d0				;		D0.W = $FFFF if ea1<ea2
	move.l		(a7)+,a1				;		D0.W = 1 if ea1>ea2
	move.l		(a7)+,a0
	jsr			misclib@0009
	movem.l		(a7)+,d1-d7/a0-a6
			endm
; ---------------------------------------------------------------------------------
SearchFile		macro						; Search a file
	movem.l		d3-d7/a2-a6,-(a7)		; In:		.L file, folder
	lea			\1(PC),a1				; out:	D0.W	folder handle
	lea			\2(PC),a0				;		D1.W	file handle
	jsr			misclib@000A			;		A0.L	adress of file VAT entry
	movem.l		(a7)+,d3-d7/a2-a6		;		A1.L	adress of file
			endm						;		D2.W	file length-2
									; Note: IF FILE NOT FOUND: A0=0; D0.W=0
; ---------------------------------------------------------------------------------
SearchFileEA		macro						; Search a file
	movem.l		d3-d7/a2-a6,-(a7)		; In:		.L pointer to filename, pointer to foldername
	move.l		\1,-(a7)				; out:	D0.W	folder handle
	move.l		\2,-(a7)				;		D1.W	file handle
	move.l		(a7)+,a0
	move.l		(a7)+,a1
	jsr			misclib@000A			;		A0.L	adress of file VAT entry
	movem.l		(a7)+,d3-d7/a2-a6		;		A1.L	adress of file
			endm						;		D2.W	file length-2
									; Note: IF FILE NOT FOUND: A0=0; D0.W=0
; ---------------------------------------------------------------------------------
SearchFolder	macro						; Search a folder
	movem.l		d1-d7/a1-a5,-(a7)		; In:		.L folder
	lea     		\1(PC),a0				; out:	D0.W folder handle
	jsr			misclib@000B			;		A0.L Folder VAT entry
	movem.l		(a7)+,d1-d7/a1-a5
			endm						; note: IF FOLDER NOT FOUND: D0.W = 0

; ---------------------------------------------------------------------------------
SearchFolderEA	macro						; Search a folder
	movem.l		d1-d7/a1-a5,-(a7)		; In:		.L pointer to foldername
	move.l     	\1,a0					; out:	D0.W folder Handle
	jsr			misclib@000B			;		A0.L	Folder VAT entry
	movem.l		(a7)+,d1-d7/a1-a5
			endm						; note: IF FOLDER NOT FOUND: D0.W = 0

; ---------------------------------------------------------------------------------
MoveMem		macro						; Copy Memory
	movem.l		d0-d7/a0-a6,-(a7)		; In:		.L Source Adress
	move.l		\1,-(a7)				;		.L Destination Adress
	move.l		\2,-(a7)				;		.L How Many Bytes
	move.l		\3,-(a7)
	move.l		(a7)+,d0
	move.l		(a7)+,a1
	move.l		(a7)+,a0
	jsr			misclib@000C
	movem.l		(a7)+,d0-d7/a0-a6
		EndM	

; ---------------------------------------------------------------------------------
RestoreScreen	macro						; Restore the whole Screen Saved by SaveScreen
	movem.l		d0-d4,-(a7)			; In:		.W Handle of Screen Data
	move.w		\1,d4
	jsr			misclib@000D
	movem.l		(a7)+,d0-d4
		endm

; ---------------------------------------------------------------------------------
SaveScreen		macro						; Saves the whole Screen
	jsr			misclib@000E			; out:	D0.W Handle of Screen
			endm	

; ---------------------------------------------------------------------------------
DrawBox		macro						; Draws a Textbox and first Save the
	movem.l		d1-d7/a0-a6,-(a7)		; whole Screen
	move.w		\1,-(a7)				; In:		.W x,y,width,height
	move.w		\2,-(a7)						.L title, textstructure
	move.w		\3,-(a7)			
	move.w		\4,-(a7)
	pea			\5(PC)				; Textstructure:
	pea			\6(PC)				; "Line1",13,"line2",13,"....",13,0
	jsr			misclib@000F			;
	movem.l		(a7)+,d1-d7/a0-a6		; Out: D0.w Handle of Saven Screen
		EndM

; ---------------------------------------------------------------------------------
DeleteFile		macro						; Deletes a File
	PushAll							; in:		.L file,folder
	SearchFile		\1,\2
	jsr			misclib@0010			; if the file is locked or hidded, it
	PopAll							; it will be unlocked to delete it.
			endm

; ---------------------------------------------------------------------------------
DeleteFileEx	macro						; Delete a File
	movem			d0/d1/d3-d7/a0-a7,-(a7)	; in:		.L file,folder
	SearchFile		\1,\2					; out:	d2.W = 0 = Error
	jsr			misclib@0011					d2.W = 1 = OK
	movem			(a7)+,d0/d1/d3-d7/a0-a7
			endm						; the attributes of the file will not be
									; changed
; ---------------------------------------------------------------------------------
DrawFrame		macro						; Draws a frame
	PushAll							; In:		.W x,y,width,height
	move.w		\1,-(a7)
	move.w		\2,-(a7)
	move.w		\3,-(a7)
	move.w		\4,-(a7)
	jsr			misclib@0012
	PopAll
			EndM

; ---------------------------------------------------------------------------------
PutImage		macro						; Puts a image
	movem.l		d0/d1/d3/a0,-(a7)		; In:		.W x,y
	move.w		\1,-(a7)				;		.L sprite
	move.w		\2,-(a7)
	lea			\3(PC),a0				; for the Spriteformat look at
	move.w		(a7)+,d1				; graphlib.h's routine Put_Sprite_mask!
	move.w		(a7)+,d0
	jsr			misclib@0013
	movem.l		(a7)+,d0/d1/d3/a0
		EndM
; ---------------------------------------------------------------------------------
CreateFile		macro						; Creates a File
	movem.l		d0-d7/a0-a5,-(a7)		; In:		.L folder,file
	pea			\1(PC)				;		.w Size-2,type,State
	pea			\2(PC)				; type:
	move.l		(a7)+,a2				;	$e0 = Textfile
	move.l		(a7)+,a1				;	$df = Picfile ...
	move.w		\3,d5					; State:
	move.w		\4,d7					;	$18 = hidden
	move.w		\5,d6					;	$08 = Locked
	jsr			misclib@0014			; Out:
	movem.l		(a7)+,d0-d7/a0-a5		; A6.W contains the error:
			endm						;	0 no error
									;	1 folder not exists
									;	2 not enough mem
									;	3 file already exists
									;	4 invalid filename
; ---------------------------------------------------------------------------------
DestroyHandle	macro						; Destroys a Handle
	PushAll							; In:		.W handle to destroy
	move.w		\1,d0
	jsr			misclib@0015
	PopAll							; NO REGS DESTROYD
		EndM

; ---------------------------------------------------------------------------------
WaitForKey		macro						; Waits for a Key
	movem.l		d0-d1,-(a7)			; In  : .W witch Key
	move.w		\1,d1					; out : nothing
	jsr			misclib@0016
	movem.l		(a7)+,d0-d1			; NO REGS DESTROYD
			EndM

; ---------------------------------------------------------------------------------
CFolderList	macro						; Creates a list of all folders
	jsr			misclib@0017			; Format:
			endM						; 3 Spaces + 8 Foldername + 3 Spaces + #13
									; Out:	d0.W	Hanlde of created list
									;		a0.L	Address of created list
; ---------------------------------------------------------------------------------
CFileList		macro						; Creates a list of all files in a folder
	move.w		\1,d0					; In:		.W Folder handle
	jsr			misclib@0018			; Format: 	See CFolderList
									; Out:	Same as CFolderList
		endM

; ---------------------------------------------------------------------------------
SendByte		macro						; Sends a Byte trough the I/O Port
	move.b		\1,d0					; In:		.B   Byte to send
	jsr			misclib@0019			; Out:	D0.L = 0   = Succeeded
			EndM						;		D0.B = $FF = Not Successfull

; ---------------------------------------------------------------------------------
ReceiveByte	macro						; Reads a Byte from I/O Port
	jsr			misclib@001A			; Out:	if a byte read : D1=1; D0=byte
		EndM							;		if no bytes    : D1=0	

; ---------------------------------------------------------------------------------
GetFolderInfo	macro						; Make a list with a lot of folder infos
	move.w		\1,d0					; In:		.W Handle of folder	
	jsr			misclib@001B			; Out:	A0.L points to InfoStructur
			endM						;		D0.W handle of InfoStructur

;InfoStructur:
;offset length        what
;  0		2	How many files in this folder = n
;  2		4	Total size of all files
;  6		4	Size of bigest file
;  10		4	Size of smalest file
;  14		n*2	Handles of all files

; ---------------------------------------------------------------------------------
DeRefD0A0		macro						; Dereference the Handle in D0.W
	jsr			misclib@001C			; In:		D0.W Handle to derefernce
			EndM						; out:	A0.L dereferenced Handle
									; Note:	This routin is usefull, because
									;		it don't destroys all registers

; ---------------------------------------------------------------------------------
ListBox		macro						; Draw a Listbox
	movem.l		d4-d7/a0-a6,-(a7)		; In:		.L	TextStructure
	pea			\1(PC)				; 		.B	X,Y,Width,Height
	move.l		(a7)+,a0				;		.W	Index top, index selected
	move.b		\2,-(a7)				;		.W	Options
	move.b		\3,-(a7)
	move.b		\4,-(a7)				; Options:
	move.b		\5,-(a7)				;   0 = only exit by esc or enter
	move.w		\6,-(a7)				;   1 = evry key exit
	move.w		\7,-(a7)				;   2 = all, but not the 4 arrows exit the box
	move.w		\8,-(a7)
	jsr			misclib@001D			; TextStructure:
	movem.l		(a7)+,d4-d7/a0-a6		;   "Line 1",13,"Line 2",13,".....",13,0
			EndM
									; Out:	D0.B	Index
									;		D1.B topindex
									;		D2.B	selindex
									;		D3.W	key pressed

; ---------------------------------------------------------------------------------
ListBoxEA		macro						; Draw a Listbox
	movem.l		d4-d7/a0-a6,-(a7)		; In:		same as ListBox but
	move.l		\1,-(a7)				; 		first Argument is a pointer to
	move.l		(a7)+,a0				;		TextStructure
	move.b		\2,-(a7)
	move.b		\3,-(a7)
	move.b		\4,-(a7)
	move.b		\5,-(a7)				; Out:	same as ListBox
	move.w		\6,-(a7)
	move.w		\7,-(a7)
	move.w		\8,-(a7)
	jsr			misclib@001E
	movem.l		(a7)+,d4-d7/a0-a6
			EndM
; ---------------------------------------------------------------------------------
CheckBoxEA		macro						; Draws a CheckBox
	movem.l		d4-d7/a0-a6,-(a7)		; In:		Same as Listbox but no
	move.l		\1,-(a7)				; 		Options
	move.l		(a7)+,a0
	move.b		\2,-(a7)				; Out:	Same as ListBox
	move.b		\3,-(a7)
	move.b		\4,-(a7)				; The TextStructure is a little bit diffrnt:
	move.b		\5,-(a7)				; - 	if the 2nd char of a line is #15 (checked),
	move.w		\6,-(a7)				;	you can uncheck it with space, it also
	move.w		\7,-(a7)				;	writes #32 to 2nd char. if also the 2nd
	jsr			misclib@001F			;	char is #32, you can check it with space
	movem.l		(a7)+,d4-d7/a0-a6		; - 	if the 2nd char is #183, then you can't
			EndM						;	check it.

; ---------------------------------------------------------------------------------
GetDLEntry		macro						; Returns the current entry in listbox
	move.w		\1,d6					; In:		.W	handle of dirlist (made by CFolderlist or CFileList)
	move.b		\2,d7					;		.B	absolut Index
	lea			\3(PC),a1				;		.L	name of buffer, where store entry (min 9 chars)					
	move.b		\4,d5					;		.B	with witch byte fill the space
	jsr			misclib@0020
			endm

; ---------------------------------------------------------------------------------
; ---------------------------------------------------------------------------------
